// Mandelbox shader by Rrrola
//KIFS formulas by Knigthy
//http://www.fractalforums.com/3d-fractal-generation/kaleidoscopic-%28escape-time-ifs%29/
// Original formula by Tglad
// - http://www.fractalforums.com/3d-fractal-generation/amazing-fractal
//rotations > Marius
//bermarte/visual
//#pragma OPENCL_EXTENSION cl_khr_fp64 : enable

#define P0 p0
#define Z0 z0                    // standard Mandelbox
#define DE de_box
#define COLOR color_box
//#define P0 vec4(par[1].x,par[1].y,par[2].y,1)  // Mandelbox Julia

#define SCALE par[0].y
#define MINRAD2 par[0].x

#define DIST_MULTIPLIER 1.0
#define MAX_DIST 4.0

// Camera position and direction.
varying vec3 eye, dir;

// Interactive parameters.
uniform vec2 par[10];

uniform float
  min_dist,           // Distance at which raymarching stops.
  ao_eps,             // Base distance at which ambient occlusion is estimated.
  ao_strength,        // Strength of ambient occlusion.
  glow_strength,      // How much glow is applied after max_steps.
  dist_to_color;      // How is background mixed with the surface color after max_steps.

uniform int iters,    // Number of fractal iterations.
  color_iters,        // Number of fractal iterations for coloring.
  max_steps;          // Maximum raymarching steps.

// Colors. Can be negative or >1 for interestiong effects.
//vec3 backgroundColor = vec3(0.07, 0.06, 0.16),
  //surfaceColor1 = vec3(0.95, 0.64, 0.1),
  //surfaceColor2 = vec3(0.89, 0.95, 0.75),
  //surfaceColor3 = vec3(0.55, 0.06, 0.03),
  //specularColor = vec3(1.0, 0.8, 0.4),
  //glowColor = vec3(0.03, 0.4, 0.4),
  //aoColor = vec3(.1, .1, .1);
//////////////
vec3 backgroundColor = vec3(0.07, 0.06, 0.16),
  surfaceColor1 = vec3(0.95, 0.12, 0.1),
  surfaceColor2 = vec3(0.29, 0.4, 0.75),
  surfaceColor3 = vec3(0.4, 0.06, 0.03),
  specularColor = vec3(1.0, 0.8, 0.4),
  glowColor = vec3(.1, 0.4, 0.4),
  aoColor = vec3(.1, .1, .1);

// precomputed constants
float minRad2 = clamp(MINRAD2, 1.0e-9, 1.0);
//vec4 scale = vec4(1.1, 1.1,1.1, abs(1.1)) / minRad2;
float absScalem1 = abs(1.1 - 1.0);//SCALE
float AbsScaleRaisedTo1mIters = pow(abs(1.1), float(1-45));
// Rotate around vector
vec4 scale = vec4(par[4].x);
float Angle = par[3].x;
float csat = cos(Angle);
float ssat = sin(Angle);
float usat = 1-cos(Angle);
vec3 z0 = normalize(vec3(par[2].x, par[2].y, par[3].y));

mat3 RotationMatrix = mat3( z0.x*z0.x*usat + csat,      z0.x*z0.y*usat + z0.z*ssat, z0.x*z0.z*usat - z0.y*ssat,
                            z0.y*z0.x*usat - z0.z*ssat, z0.y*z0.y*usat + csat,      z0.y*z0.z*usat + z0.x*ssat,
			    z0.z*z0.x*usat + z0.y*ssat, z0.z*z0.y*usat - z0.x*ssat,                                                                z0.z*z0.z*usat + csat
		      );


// Compute the distance from `pos` to the Mandelbox.
float de_box(vec3 z0) {
    float r=z0.x*z0.x+z0.y*z0.y+z0.z*z0.z;
    int i = 0;
    for (i=0;i<iters;i++){
     vec3 zz0;
            if( z0.x+ z0.y<0.0){zz0.x=-z0.y;z0.y=-z0.x;z0.x=zz0.x;}
      if( z0.x+ z0.z<0.0){zz0.x=-z0.z;z0.z=-z0.x;z0.x=zz0.x;}
      if( z0.y+ z0.z<0.0){zz0.y=-z0.z;z0.z=-z0.y;z0.y=zz0.y;}

      z0.x=scale*z0.x-(scale-1.0);//equivalent to: x=scale*(x-cx); where cx=(scale-1)/scale;
      z0.y=scale*z0.y-(scale-1.0);
      z0.z=scale*z0.z-(scale-1.0);
      r=z0.x*z0.x+z0.y*z0.y+z0.z*z0.z;
      z0.zyx*=RotationMatrix;
     
      //r=length(z0);
   }
   return (sqrt(r)-2.0)*pow(scale,float(-i));

}
vec3 color_box(vec3 pos) {
vec3 p = pos, p0 = p;
  float trap = 1.0;

  for (int i=0; i<color_iters; i++) {
    //p.xyz = clamp(p.xyz, -1.0, 1.0) * 2.0 - p.xyz;
    //p.xyz = clamp(p.xyz, -1.0, 1.0) - p.xyz;
    float r2 = dot(p.xyz, p.xyz);
    p *= clamp(r2, 0.0, 1.0);
    p = p*scale.xyz + P0.xyz;
      vec3 pp;
      if( p.x+ p.y<0.0){pp.x=-p.y;p.y=-p.x;p.x=pp.x;}//if x+y<0, x1=-y,y=-x,x=x1,endif
      if( p.x+ p.z<0.0){pp.x=-p.z;p.z=-p.x;p.x=pp.x;}//if x+z<0, x1=-z,z=-x,x=x1,endif
      if( p.x- p.y<0.0){pp.x=p.y;p.y=p.x;p.x=pp.x;}//if x-y<0, x1=y,y=x,x=x1,endif
      if( p.x- p.z<0.0){pp.x=p.z;p.z=p.x;p.x=pp.x;}//if x-z<0, x1=z,z=x,x=x1,endif
      trap = min(trap, r2);
  }
  // c.x: log final distance (fractional iteration count)
  // c.y: spherical orbit trap at (0,0,0)
  vec2 c = clamp(vec2( 0.44*log(dot(p,p))-1.0, sqrt(trap) ), 0.0, 1.0);
return mix(mix(surfaceColor1, surfaceColor2, 1.0), surfaceColor3, c.y);
  
}

/*
// Compute the color at `pos`.
vec3 color_box(vec3 pos) {
  vec3 p = pos, p0 = p;
  float trap = 1.0;

  for (int i=0; i<color_iters; i++) {
    p.xyz = clamp(p.xyz, -1.0, 1.0) * 2.0 - p.xyz;
    float r2 = dot(p.xyz, p.xyz);
    p *= clamp(max(minRad2/r2, minRad2), 0.0, 1.0);
    p = p*scale.xyz + P0.xyz;
    trap = min(trap, r2);
  }
  // c.x: log final distance (fractional iteration count)
  // c.y: spherical orbit trap at (0,0,0)
  vec2 c = clamp(vec2( 0.33*log(dot(p,p))-1.0, sqrt(trap) ), 0.0, 1.0);

  return mix(mix(surfaceColor1, surfaceColor2, c.y), surfaceColor3, c.x);
}

vec3 color_bulb(vec3 pos) {
  return surfaceColor1;
}
*/

float normal_eps = 0.00001;

// Compute the normal at `pos`.
// `d_pos` is the previously computed distance at `pos` (for forward differences).
vec3 normal(vec3 pos, float d_pos) {
  vec4 Eps = vec4(0, normal_eps, 2.0*normal_eps, 3.0*normal_eps);
  return normalize(vec3(
  // 2-tap forward differences, error = O(eps)
//    -d_pos+d(pos+Eps.yxx),
//    -d_pos+d(pos+Eps.xyx),
//    -d_pos+d(pos+Eps.xxy)

  // 3-tap central differences, error = O(eps^2)
    -DE(pos-Eps.yxx)+DE(pos+Eps.yxx),
    -DE(pos-Eps.xyx)+DE(pos+Eps.xyx),
    -DE(pos-Eps.xxy)+DE(pos+Eps.xxy)

  // 4-tap forward differences, error = O(eps^3)
//    -2.0*d(pos-Eps.yxx)-3.0*d_pos+6.0*d(pos+Eps.yxx)-d(pos+Eps.zxx),
//    -2.0*d(pos-Eps.xyx)-3.0*d_pos+6.0*d(pos+Eps.xyx)-d(pos+Eps.xzx),
//    -2.0*d(pos-Eps.xxy)-3.0*d_pos+6.0*d(pos+Eps.xxy)-d(pos+Eps.xxz)

  // 5-tap central differences, error = O(eps^4)
//    d(pos-Eps.zxx)-8.0*d(pos-Eps.yxx)+8.0*d(pos+Eps.yxx)-d(pos+Eps.zxx),
//    d(pos-Eps.xzx)-8.0*d(pos-Eps.xyx)+8.0*d(pos+Eps.xyx)-d(pos+Eps.xzx),
//    d(pos-Eps.xxz)-8.0*d(pos-Eps.xxy)+8.0*d(pos+Eps.xxy)-d(pos+Eps.xxz)
  ));
}


// Blinn-Phong shading model with rim lighting (diffuse light bleeding to the other side).
// `normal`, `view` and `light` should be normalized.
vec3 blinn_phong(vec3 normal, vec3 view, vec3 light, vec3 diffuseColor) {
  vec3 halfLV = normalize(light + view);
  float spe = pow(max( dot(normal, halfLV), 0.0 ), 32.0);
  float dif = dot(normal, light) * 0.5 + 0.75;
  return dif*diffuseColor + spe*specularColor;
}


// Ambient occlusion approximation.
float ambient_occlusion(vec3 p, vec3 n) {
  float ao = 1.0, w = ao_strength/ao_eps;
  float dist = 2.0 * ao_eps;

  for (int i=0; i<5; i++) {
    float D = DE(p + n*dist);
    ao -= (dist-D) * w;
    w *= 0.5;
    dist = dist*2.0 - ao_eps;  // 2,3,5,9,17
  }
  return clamp(ao, 0.0, 1.0);
}


void main() {
  vec3 p = eye, dp = normalize(dir);

  float totalD = 0.0, D = 3.4e38, extraD = 0.0, lastD;

  // Intersect the view ray with the Mandelbox using raymarching.
  int steps;
  for (steps=0; steps<max_steps; steps++) {
    lastD = D;
    D = DE(p + totalD * dp);

    // Overstepping: have we jumped too far? Cancel last step.
    if (extraD > 0.0 && D < extraD) {
      totalD -= extraD;
      extraD = 0.0;
      D = 3.4e38;
      steps--;
      continue;
    }

    if (D < min_dist || D > MAX_DIST) break;

    totalD += D;

    // Overstepping is based on the optimal length of the last step.
    totalD += extraD = 0.096 * D*(D+extraD)/lastD;
  }

  p += totalD * dp;

  // Color the surface with Blinn-Phong shading, ambient occlusion and glow.
  vec3 col = backgroundColor;

  // We've got a hit or we're not sure.
  if (D < MAX_DIST) {
    vec3 n = normal(p, D);
    col = COLOR(p);
    col = blinn_phong(n, -dp, normalize(eye+vec3(0,1,0)+dp), col);
    col = mix(aoColor, col, ambient_occlusion(p, n));

    // We've gone through all steps, but we haven't hit anything.
    // Mix in the background color.
    if (D > min_dist) {
      col = mix(col, backgroundColor, clamp(log(D/min_dist) * dist_to_color, 0.0, 1.0));
    }
  }

  // Glow is based on the number of steps.
  col = mix(col, glowColor, float(steps)/float(max_steps) * glow_strength);

  gl_FragColor = vec4(col, 1);
}
